# Welcome to Cppy’s documentation!

Cppy is a small C++ header library which makes it easier to write Python extension modules. The primary feature is a PyObject smart pointer which automatically handles reference counting and provides convenience methods for performing common object operations.

- Installation and use with setuptools
  - Using Cppy in an extensions
  - Use with setuptools
- Cppy smart pointer
  - CPython reference counting crash course
  - Cppy smart pointer class
  - `cppy::ptr` methods
- Error reporting
  - Functions